//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
#include "bbcreaVtkMultipleOperations.h"
#include "bbcreaVtkPackage.h"

#include "creaVtk_MACROS.h"

namespace bbcreaVtk
{

BBTK_ADD_BLACK_BOX_TO_PACKAGE(creaVtk,MultipleOperations)
BBTK_BLACK_BOX_IMPLEMENTATION(MultipleOperations,bbtk::AtomicBlackBox);
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void MultipleOperations::Process()
{
// THE MAIN PROCESSING METHOD BODY
//   Here we simply set the input 'In' value to the output 'Out'
//   And print out the output value
// INPUT/OUTPUT ACCESSORS ARE OF THE FORM :
//    void bbSet{Input|Output}NAME(const TYPE&)
//    const TYPE& bbGet{Input|Output}NAME() const 
//    Where :
//    * NAME is the name of the input/output
//      (the one provided in the attribute 'name' of the tag 'input')
//    * TYPE is the C++ type of the input/output
//      (the one provided in the attribute 'type' of the tag 'input')

	if ( bbGetInputInLst().size()>0 )
	{
		int 			extImage[6];
		vtkImageData 	*resultImage=NULL;
		bbGetInputInLst()[0]->GetExtent( extImage );
		int dimXImage 	= extImage[1]-extImage[0]+1;
		int dimYImage	= extImage[3]-extImage[2]+1;
		int dimZImage 	= extImage[5]-extImage[4]+1;
		if (bbGetOutputOut()!=NULL) 
		{
			bbGetOutputOut()->Delete();
		}	
		resultImage = vtkImageData::New();
		resultImage->Initialize();
		resultImage->SetSpacing( bbGetInputInLst()[0]->GetSpacing() );
		resultImage->SetDimensions(  dimXImage, dimYImage, dimZImage );
		resultImage->AllocateScalars( bbGetInputInLst()[0]->GetScalarType(),1 );
		long int index,size=dimXImage*dimYImage*dimZImage;
		DEF_POINTER_IMAGE_VTK_CREA(vOut,ssOut,pOut,stOut,resultImage )
		if (bbGetInputType()==20)
		{

long int k1omp=(double)(size-1)*0.0;
long int k2omp=(double)(size-1)*0.2;
long int k3omp=(double)(size-1)*0.4;
long int k4omp=(double)(size-1)*0.6;
long int k5omp=(double)(size-1)*0.8;
long int k6omp=(double)(size-1)*1.0;

printf("EED MultipleOperations::Process (with openmp)\n");
#pragma omp parallel for
			for (index=0;index<size;index++)
			{
if ( (k1omp==index) || (k2omp==index) || (k3omp==index) || 
     (k4omp==index) || (k5omp==index) || (k6omp==index) ) { printf("  %d%\n", (int)(((double)index/(double)(size-1))*100 )); }

				DEF_POINTER_IMAGE_VTK_CREA(vIn ,ssIn ,pIn ,stIn ,bbGetInputInLst()[0] )
				int iLst,sizeLst= bbGetInputInLst().size();
				double vInBack,acumDiff;
				acumDiff=0;
				for (iLst=0;iLst<sizeLst;iLst++) // volumes
				{
					pIn=(char*)( bbGetInputInLst()[iLst]->GetScalarPointer() );
					GETVALUE2_VTK_CREA(vIn,pIn,stIn,index)
					if (iLst!=0)
					{
						acumDiff = acumDiff+abs(vIn-vInBack);
					} 
					vInBack=vIn;
				} // for iLst
				acumDiff = acumDiff/sizeLst;
				SETVALUE2_VTK_CREA(acumDiff,pOut,stOut,index)
			} // for index
		} // if Type==20
		bbSetOutputOut( resultImage );
	} // if InLst size
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void MultipleOperations::bbUserSetDefaultValues()
{

//  SET HERE THE DEFAULT INPUT/OUTPUT VALUES OF YOUR BOX 
//    Here we initialize the input 'In' to 0
  
   bbSetInputType(0);
   bbSetOutputOut(NULL);

}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void MultipleOperations::bbUserInitializeProcessing()
{

//  THE INITIALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should allocate the internal/output pointers 
//    if any 

  
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void MultipleOperations::bbUserFinalizeProcessing()
{

//  THE FINALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should desallocate the internal/output pointers 
//    if any
  
}
}
// EO namespace bbcreaVtk


